---
image: python:3.9

cache:
  paths:
    - .cache/pip

variables:
  PARENT_PIPELINE_ID: "{{ parent_pipeline_id }}"
  BASE_SIM_ID: "{{ base_sim_id }}"
  SITE: "{{ site }}"

stages:
  - build
  - test
  - pre-cleanup # This stage can go away after DAG (needs:) supports same stage ordering https://gitlab.com/gitlab-org/gitlab/-/issues/30632
  - cleanup

# duplicate sim, update name and push runner reg commands in same job
# these things all need to happen in very close time with each other
duplicate snapshot:
  stage: build
  before_script:
    - pip3 install jinja2
    - pip3 install requests
    - pip3 install git+https://gitlab.com/cumulus-consulting/air/cumulus_air_sdk.git
  script:
    - python3 scripts/duplicate_snapshot.py
    - python3 scripts/push_runner_commands.py
  artifacts:
    expire_in: 1 week
    untracked: true

test from oob-mgmt:
  stage: test
  retry: 2
  script:
    - sleep 120
    - bash tests/oob-mgmt-tests.sh
  tags:
    - {{ site }}:{{ parent_pipeline_id }}:oob-mgmt-server
  dependencies: []

oob-mgmt runner delete:
  stage: pre-cleanup
  script:
    - sudo gitlab-runner unregister --all-runners
  tags:
    - {{ site }}:{{ parent_pipeline_id }}:oob-mgmt-server
  needs:
    - test from oob-mgmt

# delete the test simulation
cleanup and report:
  stage: cleanup
  before_script:
    - pip3 install requests
    - pip3 install python-gitlab
    - pip3 install git+https://gitlab.com/cumulus-consulting/air/cumulus_air_sdk.git
  script:
    - python3 scripts/cleanup_test_sim.py
  artifacts:
    expire_in: 1 week
    untracked: true

